proc getPrintOptionsDone {ret} {
	global pr
	set pr(options) ""
	if {$ret} {
		append pr(options) " -colormode $pr(mode)"
		append pr(options) " -rotate $pr(rotate)"
### convert width (inches) to postscript units (1/72 in)
		append pr(options) " -pagewidth [expr $pr(width) * 72]"
### set drawing size to print
		set sclr [lindex [.c.c config -scrollregion] 4] 
		append pr(options) " -width [lindex $sclr 2] -height [lindex $sclr 3]"
		if {$pr(file)} {
			eval .c.c postscript $pr(options) -file $pr(filename) 
		} else {
			set f [open "|lpr" w]
			puts $f [eval .c.c postscript $pr(options)]
			close $f
		}
	}
	destroy .pr
}

proc getPrintOptions {} {
	global pr sld
	toplevel .pr
	wm transient .pr .
	frame .pr.ft
	frame .pr.ft.l -bd 3 -relief sunken
	label .pr.ft.l.title -text "color mode"
	radiobutton .pr.ft.l.color -text Color \
		-variable pr(mode) -value color
	radiobutton .pr.ft.l.gray -text gray \
		-variable pr(mode) -value gray 
	radiobutton .pr.ft.l.mono -text "b&w" \
		-variable pr(mode) -value mono
	.pr.ft.l.color invoke
	pack .pr.ft.l.title .pr.ft.l.color .pr.ft.l.gray .pr.ft.l.mono -side top
	frame .pr.ft.r
	radiobutton .pr.ft.r.land -bitmap @$sld(idir)/landscape.xbm \
		-variable pr(rotate) -value 1
	radiobutton .pr.ft.r.port -bitmap @$sld(idir)/portrait.xbm \
		-variable pr(rotate) -value 0
	.pr.ft.r.land invoke
	pack .pr.ft.r.port .pr.ft.r.land -side left 
	scale .pr.ft.width -resolution 0.1 -showvalue 1 \
		-from 5 -to 14 -variable pr(width) \
		-label "drawing width (inches)" -orient horizontal -digits 3
	.pr.ft.width set 11.0 
	pack .pr.ft.l -side left
	pack .pr.ft.r -side top
	pack .pr.ft.width -expand 1 -fill x
	frame .pr.fm
	checkbutton .pr.fm.b -text "to file" \
		-variable pr(file) -onvalue 1 -offvalue 0
	entry .pr.fm.e -width 30 -textvariable pr(filename)
	pack .pr.fm.b .pr.fm.e -side left -fill x -expand 1
	frame .pr.fb
	button .pr.fb.cancel -text cancel -command { getPrintOptionsDone 0 }
	button .pr.fb.print -text print -command { getPrintOptionsDone 1 }
	pack .pr.fb.cancel .pr.fb.print -side left -fill x -expand 1
	pack .pr.ft .pr.fm .pr.fb -fill x -expand 1 -side top
	centerWindow .pr
	raise .pr
}


proc fileExport {} {
	toplevel .exp
	wm transient .exp .
	frame .exp.f
	radiobutton .exp.f.eps -text "Encapsulated PostScript" \
		-variable fmt -value eps
	radiobutton .exp.f.xfig -text XFig -variable fmt -value xfig \
		-state disabled
	radiobutton .exp.f.xpm -text xpm -variable fmt -value xpm \
		-state disabled
	.exp.f.eps invoke
	pack .exp.f.eps .exp.f.xfig .exp.f.xpm -side left
	frame .exp.f1
	checkbutton .exp.f1.z -text gzipped -variable gzipped
	entry .exp.f1.fn -width 40
	pack .exp.f1.z .exp.f1.fn -side left
		# puts $fd [.c.c postscript]
		update
	frame .exp.f2
	button .exp.f2.export -text export -command {
		set fd [open [.exp.f1.fn get] w]
		puts $fd [.c.c postscript]
		close $fd
		destroy .exp
	} 
	button .exp.f2.cancel -text cancel -command {destroy .exp}
	button .exp.f2.browse -text browse -command {
		.exp.f1.fn delete 0 end; .exp.f1.fn insert end [tk_getSaveFile]}
	pack .exp.f2.export .exp.f2.cancel .exp.f2.browse \
		-side left -anchor c
	pack .exp.f .exp.f1 .exp.f2 -side top
	centerWindow .exp
	raise .exp
}
